unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AutoScroll;

type
  TForm1 = class(TForm)
    AutoScroll1: TAutoScroll;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0: AutoScroll1.ScrollType := stScrollAll;
    1: AutoScroll1.ScrollType := stScrollLeftRight;
    2: AutoScroll1.ScrollType := stScrollUpDown;
  end;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  case RadioGroup2.ItemIndex of
    0: AutoScroll1.HookedMessage := hmLeftClick;
    1: AutoScroll1.HookedMessage := hmMiddleClick;
    2: AutoScroll1.HookedMessage := hmRightClick;
    3: AutoScroll1.HookedMessage := hmLeftDblClick;
    4: AutoScroll1.HookedMessage := hmMiddleDblClick;
    5: AutoScroll1.HookedMessage := hmRightDblClick;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RadioGroup1Click(Self);
  RadioGroup2Click(Self);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  AutoScroll1.FocusControl := Memo1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  AutoScroll1.FocusControl := nil;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if AutoScroll1.Active then
  begin
    AutoScroll1.Active := False;
    Button3.Caption := 'Start Scrolling';
    AutoScroll1.ScrollMode := smAuto;
  end
  else
  begin
    AutoScroll1.ScrollMode := smManual;
    AutoScroll1.Active := True;
    Button3.Caption := 'Stop Scrolling';
  end;
end;

end.
